	TITLE	'XFERUSB4.ABS'
	STL	'Dan S. Emrick, 03/12/2013'
*
*  In order to match Norberto's hardware, modified 3/12/2013 to use port 260Q
*    for data and 2262Q for status.  Also inverted sense of *RTE and *TXE in
*    the USBSTAT status byte.
*
* ================================================================

*	TITLE	'XFERUSB3.ABS'
*	STL	'Dan S. Emrick, 03/31/2010'

*	Send/Receive files from PC using HLink (Linux) or HLink.exe (Windows)
*	
*  Menu item to send a file:
*  Get file name from user.  Look up entry in DIRECT.SYS, load GRT.SYS,
*    follow group chain to calculate file size. 
*  Send a command packet to PC stating desire to send a file, include byte
*    count.
*  PC acknowledges request as valid.
*  H89 sends data packet with file name.  PC extracts file name, creates
*    file in the current directory and sends acknowledgement packet.
*  H89 sends file and checksum.  When byte count expires, PC
*    checks checksum, sends acknowledgement and returns to event loop.
*  H89 gets acknowledgement and returns to menu.

*  Menu item to receive file:
*  Get local device for storage from user (SY0:, RD0:, PC0:, etc.), sets
*    device name in file name area.
*  H89 sends command packet requesting to get a file.  PC opens file
*    dialog so user can navigate to file to be sent.  File name must
*    meet 8x3 convension; check or convert it.	PC calculates files size.
*  PC sends data packet with byte count and file name.	H89 opens file,
*    sends acknowledgement to PC.  PC begins sending bytes.  When byte
*    count expires, H89 closes file and sends report to PC. PC reports
*    status to user and returns to event loop.

	XTEXT	HOSDEF
	XTEXT	DOLLAR
	XTEXT	ASCII

	ORG	042200A

SBC.DE	EQU	122355A
S.OMAX	EQU	040324

*USBDAT	EQU	340Q
*USBSTAT EQU	341Q

USBDAT	EQU	260Q
USBSTAT EQU	262Q
USBRX	EQU	2
USBTX	EQU	1

USBBUSY EQU	1		transmitter ready flag

EC.EOF	EQU	1
DIRELEN EQU	23

START.1 EQU	*
	CALL	$TYPTX
	DB	NL,NL
	DB	TAB,'Select function:',NL
	DB	TAB,'S	-  Send file to PC',NL
	DB	TAB,'R	-  Receive file from PC',NL
	DB	TAB,'E	-  Exit program'
	DB	NL,NL
	DB	TAB,'Enter S, R, or E:'
	DB	' '+200Q

FUNC	SCALL	.SCIN
	JC	FUNC

	PUSH	PSW
	MVI	A,NL
	SCALL	.SCOUT
	POP	PSW

	CPI	'S'
	JZ	SEND.F

	CPI	'R'
	JZ	REC.F

	CPI	'E'
	JZ	DONE

	CALL	$TYPTX
	DB	'Unknown option, please try again.'
	DB	NL,ENL
	JMP	START.1

REC.F	EQU	*
* Ask user for storage device
	CALL	$TYPTX
	DB	'Storgage device specification (eg. SY0:, PC0:, etc.):'
	DB	' '+200Q

	LXI	H,DEF.DEV
	CALL	GETLINE
	SHLD	DEV.ADR
	XCHG
	LXI	H,DEF.DEV
	XCHG
	DW	SBC.DE
	SHLD	DEV.LEN

* (HL) = number of characters entered
	MOV	A,L
	CPI	4
	JNZ	BADDEV

SETDEV	EQU	*
	LXI	H,DEF.DEV
	LXI	D,3
	DAD	D
	MOV	A,M
	CPI	':'
	JZ	REQFIL

BADDEV	EQU	*
	CALL	$TYPTX
	DB	'Incorrect device specification, try again'
	DB	ENL
	JMP	REC.F

* Send Control Packet requesting PC send us a file
REQFIL	EQU	*
	MVI	B,12
	LXI	H,SND.BYT
	CALL	SEND.IT

* PC should respond by opening a file select dialog
* Tell user to go to PC and select a file
	CALL	$TYPTX
	DB	NL
	DB	'On your PC, select the file to transfer'
	DB	ENL

*  PC sends data packet with byte count and file name.	H89 opens file,
*    sends acknowledgement to PC.  PC begins sending bytes.  When byte
*    count expires, H89 closes file and sends report to PC. PC reports
*    status to user and returns to event loop.

* Get data Packet from PC containing file name and file length
	LXI	H,RES.PKT	response packet buffer
	CALL	RED.PKT 	gets file length into RES.PKT
*				and file name into RES.NAM

	PUSH	H
	PUSH	D
	PUSH	B
	LHLD	RES.PKT
	PUSH	H
	POP	B
	LXI	H,REC.SIZ
	MVI	A,5
	CALL	$UDD

	CALL	$TYPTX
	DB	'Expecting '
REC.SIZ DB	'00000 bytes'
	DB	ENL

	POP	B
	POP	D
	POP	H

* Open the file for writing
	LXI	H,RES.NAM
	LXI	D,DEF.DEV
	MVI	A,1
	SCALL	.OPENW
	JNC	REQ.1

	CALL	$TYPTX
	DB	'Cannot open file to save'
	DB	ENL
	JMP	DONE

REQ.1	EQU	*
	CALL	$TYPTX
	DB	'File open for write'
	DB	ENL

* Get data and write file one sector at a time
	LHLD	RES.PKT
	XCHG			byte count in DE
*	DCR	D		predecrement

REQ.2	EQU	*
	PUSH	D		save incoming byte count
	LXI	H,BUFFER
	LXI	B,256
	CALL	IN.BLK		get 256 bytes from USB

	MVI	A,1
	LXI	B,256
	LXI	D,BUFFER
	SCALL	.WRITE
	JNC	REQ.3

	CALL	$TYPTX
	DB	'Error attempting to write save file'
	DB	ENL
	POP	D
	JMP	DONE

REQ.3	EQU	*
	POP	D		get incoming byte count back
	DCR	D		decrease by 256
	JNZ	REQ.2

* When byte count expires, close file and return to menu

	MVI	A,1
	SCALL	.CLOSE
	LXI	H,ACK.PKT
	MVI	B,12
	CALL	SEND.IT 	tell PC we're OK
	JMP	START.1

SND.BYT DB	12,0
SND.CMD DB	6	command to send file to H89
	DS	8,0	reserved
SND.CHK DB	0	checksum


SEND.F	EQU	*
	XRA	A
	STA	LOOP
	STA	REP

	CALL	$TYPTX
	DB	'Enter name of file to send to PC:'
	DB	' '+200Q

	LXI	H,BUFFER	use BUFFER as temp work area
	CALL	GETLINE
	CALL	SETNAME 	decode entry for .OPEN and for
*				directory search

	LXI	D,DEF.DEV	open file to determine it exists
	LXI	H,FNAME
	MVI	A,1
	SCALL	.OPENR
	JNC	CALCSIZ 	go determine byte count

	CALL	$TYPTX
	DB	'Cannot open input file'
	DB	ENL
	JMP	EXIT.

CALCSIZ EQU	*
	MVI	A,1
	SCALL	.CLOSE		close for now
	JNC	CALC1

	CALL	$TYPTX
	DB	'Unable to close file'
	DB	ENL
	JMP	DONE

CALC1	EQU	*
	CALL	$TYPTX
	DB	'Found file and closed it for now'
	DB	ENL
	CALL	GETNTRY 	locate directory entry
	JNC	CNTSEC		found entry, go count up sectors

	CALL	$TYPTX
	DB	'Directory entry not found'	shouldn't happen
	DB	ENL
	JMP	EXIT.

LOGIT	MVI	A,3
	LXI	H,LNAME
	LXI	D,DBLCK
	SCALL	.OPENW

	MVI	A,3
	LXI	B,512
	LXI	D,PATTERN
	SCALL	.WRITE
	JNC	LOG.DON

	CALL	$TYPTX
	DB	'Could not write log file'
	DB	ENL
	RET
LOG.DON MVI	A,3
	SCALL	.CLOSE
	RET

DBLCK	DB	'RD0:',0,0,0
LNAME	DB	'LOGFILE.DAT',0,0


CNTSEC	EQU	*		have entry in directory
	LXI	D,DIRNTRY
	MVI	B,23
CNT.1	MOV	A,M		move directory entry to work area
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	CNT.1

	CALL	$TYPTX
	DB	'Directory entry moved to work area'
	DB	ENL

	MVI	A,2
	LXI	D,DEF.DEV
	LXI	H,GRTNAME
	SCALL	.OPENR
	JNC	GETGRT

	CALL	$TYPTX
	DB	'Error opening GRT.SYS'
	DB	ENL
	JMP	EXIT.

GETGRT	EQU	*
	MVI	A,2
	LXI	B,256
	LXI	D,BUFFER
	SCALL	.READ		GRT now in buffer

	MVI	A,2
	SCALL	.CLOSE

	LXI	B,0		clear group counter

	LDA	ENT.FGN 	get 1st GRT group
GET.1	LXI	H,BUFFER
	MOV	E,A
	MVI	D,0
	DAD	D		point to group
	MOV	A,M		fetch next group number it
	ORA	A
	JZ	LSTGRP		this is the last group

	INX	B		count this group
	JMP	GET.1		check next group

LSTGRP	EQU	*
	DCX	B		decrease by 1 group so
	PUSH	B		that adding # sectors in
	POP	D		last group gives good result
*
	LDA	ENT.CLU 	get cluster factor
	INR	A
	CALL	$MU86		partial sector count in HL
	LDA	ENT.LSI 	number of sectors in last group
	MOV	E,A
	MVI	D,0
	DAD	D		(HL) = sector count
	SHLD	SECCNT		save it

	PUSH	H
	POP	B
	LXI	H,SHOCNT
	MVI	A,5
	CALL	$UDD
	CALL	$TYPTX
	DB	'Sector count = '
SHOCNT	DB	'00000'
	DB	ENL
	JMP	XMIT

GETNTRY EQU	*
	LXI	D,DEF.DEV
	LXI	H,DIRNAME
	MVI	A,1
	SCALL	.OPENR		open directory for selected device
	JNC	DREAD

	CALL	$TYPTX
	DB	'Cannot read DIRECT.SYS'
	DB	ENL
	JMP	EXIT.

DREAD	EQU	*

	CALL	$TYPTX
	DB	'DIRECT.SYS open'
	DB	ENL
	MVI	A,1
	LXI	B,512		2 directory sectors
	LXI	D,BUFFER	where to put them
	SCALL	.READ
	JNC	LDE0

	CALL	$TYPTX
	DB	'Error reading directory block'
	DB	ENL
	JMP	EXIT.

LDE0	EQU	*
	CALL	$TYPTX
	DB	'Directory block read'
	DB	ENL

	LXI	B,11		name length
	LXI	H,BUFFER
LDE3	LXI	D,PATTERN
	MOV	A,M		1st char of dir entry
	ORA	A
	JZ	LDE6		end of directory, file name not found

	INR	A
	JZ	LDE5		empty entry

	INR	A
	JZ	LDE6		no more files in directory

	PUSH	B		save copy of (BC)
	PUSH	H		save address
	CALL	$COMP		compare
	POP	H
	POP	B
	RZ			got match

LDE5	LXI	D,DIRELEN	not yet, check next entry
	DAD	D
	MOV	A,M
	ANA	A
	JNZ	LDE3		more in this block

*  not in this block, try another one

	JMP	DREAD

LDE6	EQU	*
	MVI	A,1
	SCALL	.CLOSE
	STC
	RET

XMIT	EQU	*
*  Set up command packet to alert PC file is coming

	MVI	A,5		command PC to accept file
	STA	CMD.CMD
	LHLD	SECCNT		get size of file in sectors
	MOV	A,L
	STA	CMD.CNT
	MOV	A,H
	STA	CMD.CNT+1	tell PC  number of sectors to expect

	LXI	H,CMD.PKT
	MVI	B,12		defined command packet size
	CALL	SEND.IT

*	get acknowledgement

	LXI	H,ACK.BUF
	CALL	RED.PKT 	get acknowledgement packet
	CALL	CHK.ACK 	check for valid acknowledgement
	RC			return with error code in ACC

	LXI	H,FNAME
	LXI	D,FIL.NAM
	MVI	B,12
XMIT.1	MOV	A,M		move file name to data packet
	STAX	D
	INX	D
	INX	H
	DCR	B
	JNZ	XMIT.1

	LXI	H,FIL.PKT
	MVI	B,19		packet size
	CALL	SEND.IT

	LXI	H,ACK.BUF
	CALL	RED.PKT 	get acknowledgement packet
	CALL	CHK.ACK 	check for valid acknowledgement
	RC			return with error code in ACC

	LXI	D,DEF.DEV	open file to send
	LXI	H,FNAME
	MVI	A,3
	SCALL	.OPENR

READ.1	EQU	*
	MVI	A,3		ch number
	LXI	B,256		count of bytes to read
	LXI	D,BUFFER	where to put them

	SCALL	.READ
	JNC	READ.2

	CPI	EC.EOF
	JZ	GOMENU

	CALL	$TYPTX
	DB	'Error reading file'
	DB	ENL
	JMP	EXIT.

GOMENU	EQU	*
	MVI	A,3
	SCALL	.CLOSE
	JMP	START.1

DONE	EQU	*
	MVI	A,3
	SCALL	.CLOSE
	JMP	EXIT.

READ.2	EQU	*
	LXI	H,BUFFER	start of buffer
	MVI	B,0		256 bytes
	CALL	SEND.IT
	LHLD	SECCNT
	DCX	H
	SHLD	SECCNT
	MOV	A,H
	ORA	L
	JNZ	READ.1		go get another sector 'til EOF
	JMP	GOMENU

SEND.IT EQU	*		send 256 bytes or less
**	Enter with HL pointing to data,
**	(B)= byte count, 0=>256
**

	PUSH	H
	PUSH	B
	PUSH	D
	LDA	LOOP
	MOV	C,A
	MVI	B,0
	MVI	A,3
	LXI	H,SHOL
	CALL	$UDD
	CALL	$TYPTX
SHOL	DB	'000 '
	DB	'-'+200Q
	LDA	LOOP
	INR	A
	STA	LOOP

	LDA	REP
	INR	A
	STA	REP
	CPI	10
	JNZ	SHOL.1

	MVI	A,NL
	SCALL	.SCOUT
	XRA	A
	STA	REP

SHOL.1	POP	D
	POP	B
	POP	H

SEND.1	IN	USBSTAT
	ANI	USBTX
	JZ	SEND.1
*	JNZ	SEND.1

	MOV	A,M
	OUT	USBDAT
*	SCALL	.SCOUT
	INX	H
	DCR	B
	JNZ	SEND.1
	RET

RED.PKT EQU	*		read packet from PC
**
**	(HL) = buffer to store data that is retrieved
**	1st 2 bytes => incoming byte count
**	Return with next buffer address in DE

	IN	USBSTAT
	ANI	USBRX
	JZ	RED.PKT
*	JNZ	RED.PKT

	IN	USBDAT
	MOV	C,A		LSByte of byte count

RED.1	EQU	*
	IN	USBSTAT
	ANI	USBRX
	JZ	RED.1
*	JNZ	RED.1

	IN	USBDAT		MSByte of byte count
	MOV	B,A		(BC) = byte count

	PUSH	B
	PUSH	H
	LXI	H,RED.SIZ
	MVI	A,5
	CALL	$UDD
	CALL	$TYPTX
	DB	'pkt size '
RED.SIZ DB	'00000'
	DB	ENL
	POP	H
	POP	B

	DCX	B
	DCX	B	subtract 2 bytes from count
	CALL	IN.BLK

	PUSH	H
	POP	D	next address in DE
	RET


IN.BLK	EQU	*	Get a block from PC
**	Entry
**	(BC) = number of bytes expected
**	(HL) = caller's buffer to store data
**
IN.1	IN	USBSTAT
	ANI	USBRX
	JZ	IN.1
*	JNZ	IN.1

	IN	USBDAT
	MOV	M,A
	INX	H
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	IN.1
	RET


CHK.ACK EQU	*
	LDA	ACK.BUF 	1st "live" byte of Acknowledgement Packet
	ORA	A		check error code returned by PC
	RET

*	Come here to restore console and exit

CC.XIT	EQU	*
	CALL	$TYPTX
	DB	NL,'Control-C exit or abort',ENL
	DB	ENL

EXIT.	EQU	*
	CALL	LOGIT
	MVI	B,80
	MVI	C,-1
	MVI	A,3
	SCALL	.CONSL		restore 80 char screen width
	MVI	B,203Q		BS, no case map, map BKSP, term. proc. tab
	MVI	C,-1
	MVI	A,1
	SCALL	.CONSL

	XRA	A
	SCALL	.EXIT

CLOSIT	EQU	*
	PUSH	PSW
	MVI	A,1
	SCALL	.CLOSE
	POP	PSW
	RET

GETLINE EQU	*	enter w/HL pointing to file name buffer
	SCALL	.SCIN
	JC	GETLINE
	CPI	NL
	JZ	GETDONE

	CPI	BKSP
	JZ	CORRECT

	CPI	RUBOUT
	JZ	CORRECT

	MOV	M,A
	INX	H
	JMP	GETLINE

CORRECT EQU	*
	DCX	H
	MVI	A,' '
	SCALL	.SCOUT
	MVI	A,BKSP
	SCALL	.SCOUT
	JMP	GETLINE

GETDONE MVI	M,0
	RET

SETNAME EQU	*
	LXI	H,BUFFER	point to user entry
	SHLD	BUF.PTR
	CALL	COLON		locate ':' if any
	JC	NOCOLN		none found, so no device entered, use default

	INX	H
	SHLD	BUF.PTR 	save pointer past ':'
	LXI	D,DEF.DEV	
	MVI	B,4
	LXI	H,BUFFER	start w/device name
SET.1	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	SET.1
	XRA	A
	STAX	D		add null

NOCOLN	EQU	*
*  First copy name to FNAME location, then break in down for directory use
	LHLD	BUF.PTR
	MVI	B,12
	LXI	D,FNAME
NOC.0	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B
	JNZ	NOC.0
	XRA	A
	STAX	D		trailing null

*  Now move file name to work area for directory compare

	LHLD	BUF.PTR 	pointer to file name
	MVI	B,8		length of name
	LXI	D,PATTERN
NOC.1	MOV	A,M
	ORA	A
	CZ	PADD		pad end of name w/nulls

	JZ	FILEEND 	end of file name input by user

	CPI	'.'		start of ext?
	CZ	PADD		pad end of name w/nulls
	JZ	DOEXT		handle the extension

	STAX	D
	INX	D
	INX	H
	DCR	B
	JNZ	NOC.1

DOEXT	EQU	*
	INX	H		inc past '.'
	MOV	A,M
	ORA	A
	JZ	FILEEND 	end of file name input by user

	MVI	B,3
CNT.2	EQU	*	
	MOV	A,M
	ORA	A
	CZ	PADD
	JZ	FILEEND

	STAX	D
	INX	D
	INX	H
	DCR	B
	JNZ	CNT.2

FILEEND EQU	*
	CALL	PADD
	RET

COLON	EQU	*
	MVI	B,4
	MVI	A,':'
COL1	CMP	M
	JZ	GOTCOLN 	found one, ret w/address in HL

	INX	H
	DCR	B
	JNZ	COL1
	STC
	RET

GOTCOLN EQU	*
	XRA	A
	RET

PADD	EQU	*
	MOV	A,B
	ORA	A
	RZ

	XRA	A
PAD1	STAX	D
	INX	D
	DCR	B
	JNZ	PAD1
	RET

* Data area followed by initialization code that is later overwritten

LOOP	DB	0
REP	DB	0

*  Command packet area 

ACK.BUF DS	12
	DB	0,0,0,0

ACK.PKT DB	12,0		byte count
ACK.COD DB	1		OK
	DS	8,0		reserved
ACK.CHK DB	0		command packet checksum

CMD.PKT DB	12,0		byte count
CMD.CMD DB	5		command to accept 1 file
	DB	0,0		reserved
CMD.CNT DB	0,1		number of sectors to be sent
	DB	0,0,0,0 	reserved
CMD.CHK DB	0		command packet checksum

*  File packet area 


FIL.PKT DB	19,0		byte count
FIL.NAM DS	12,0		name of file to send
	DB	0,0,0,0 	reserved
FIL.CHK DB	0		command packet checksum

************************

C.HRDW	DB	0
C.BYTE	DB	0

SECCNT	DB	0,0

PATTERN DS	12,0	file name pattern to find in DIRECT.SYS

RES.PKT DB	0,0
RES.NAM DS	12,0
RES.CHK DB	0

DEF.DEV DB	'RD0:',0,0,0
	DB	0,0,0,0,0		pad in case user dev. entry is too long
FNAME	DB	'READTEST.DAT',0

DEV.LEN DB	0,0
DEV.ADR DB	0,0

GRTNAME DB	'GRT.SYS',0,0,0,0,0
DIRNAME DB	'DIRECT.SYS',0,0,0

DIRNTRY DS	8,0	working file name
ENT.EXT DS	3,0	working file extension
	DS	2,0	unused
ENT.CLU DB	0	cluster factor
	DS	2,0	unused
ENT.FGN DB	0	1st group number
ENT.LGN DB	0	last group number
ENT.LSI DB	0	last sector index
ENT.CRD DS	2,0	creation date
ENT.ALD DS	2,0	alteration date

BUF.PTR DB	0,0
BUFFER	EQU	*


* Initialization code; overwritten later

START	EQU	*		set up control-C exit
	MVI	A,3
	LXI	H,CC.XIT
	SCALL	.CTLC

	MVI	A,3
	MVI	C,0
	SCALL	.CONSL
	STA	C.BYTE

	MVI	A,3
	MVI	B,-1
	MVI	C,-1
	SCALL	.CONSL

	MVI	A,1
	MVI	C,0
	SCALL	.CONSL
	STA	C.HRDW

	MVI	A,0
	MVI	B,1
	MVI	C,1
	SCALL	.CONSL		set character mode

	MVI	A,0		load both overlays
	SCALL	.LOADO
	JC	OVL.ERR

	MVI	A,1
	SCALL	.LOADO
	JC	OVL.ERR

	LXI	H,-1
	SCALL	.SETTOP
	LXI	D,S.OMAX
	DW	SBC.DE
	LXI	D,-10
	DAD	D
	SHLD	MAXMEM
	SCALL	.SETTOP

	LHLD	MAXMEM		show user top of memory
	MVI	A,6
	MOV	B,H
	MOV	C,L
	LXI	H,HIMEM
	CALL	$UDD
	LXI	H,HIMEM

	CALL	$TYPTX
	DB	12Q
	DB	'High memory limit established - '
HIMEM	DB	'000000',ENL

	JMP	START.1

SET.ERR EQU	*
	CALL	$TYPTX
	DB	'.SETTOP error'
	DB	ENL
	JMP	CC.XIT

OVL.ERR EQU	*
	CALL	$TYPTX
	DB	'.LOADO error'
	DB	ENL
	JMP	CC.XIT

MAXMEM	DB	0,0
TAG.0	DB	'SEND.ASM,  09/23/2009,  5:55 PM',0
	DB	'SEND1.ASM,   09/25/2009,  4:45 PM',0
	DB	'SENDUSB.ASM, 02/13/2010,  7:40 PM',0
	DB	'SENDUSB.ASM, 03/29/2010,  8:25 PM',0
	DB	'XFERUSB.ASM, 03/31/2010,  3:45 PM',0
	DB	'XFERUSB2.ASM, 04/02/2010,  7:45 PM',0
	DB	'XFERUSB3.ASM, 04/07/2010,  4:45 PM',0
	DB	'XFERUSB4.ASM, 03/12/2010,  6:50 PM',0

	LON	L

	END	START
